#include <PalmOS.h>
#include "StarterRsc.h"
#include "WristPDA.h"
#include "JotAPI.h"

#define JotAppFileCreator    'JWJT'
#define JotAppPrefID         0x00
#define JotAppPrefVersionNum 0x01

typedef struct JotPrefType {
  UInt8  enabled; //1
  UInt8  dummy1;  //1
  UInt32 dummy2;  //4
  UInt32 dummy3;  //4
  UInt32 dummy4;  //4
  UInt32 dummy5;  //4
  UInt32 dummy6;  //4
} JotPrefType;
static JotPrefType JotPrefVal;

Boolean MakeJotEnable = false;

static void
ChangePreferenceVal()
{
  UInt16 JotPrefSize = sizeof(JotPrefVal);
  if (PrefGetAppPreferences(JotAppFileCreator, JotAppPrefID,
      &JotPrefVal, &JotPrefSize, true) != noPreferenceFound) {
    if (JotPrefVal.enabled == 0x00) {
      JotPrefVal.enabled = 0x01;
      MakeJotEnable = true;
    } else {
      JotPrefVal.enabled = 0x00;
      MakeJotEnable = false;
    }
    PrefSetAppPreferences(JotAppFileCreator, JotAppPrefID,
                          JotAppPrefVersionNum, &JotPrefVal,
                          JotPrefSize, true);
  }
}

static void
ChangeJot()
{
  Err err = errNone;
  UInt16 cardNo;
  LocalID dbID = NULL;
  DmSearchStateType searchState;
  UInt32 fFeature;

  err = DmGetNextDatabaseByTypeCreator(true, &searchState, sysFileTApplication,
                                       JOTCREATOR, true, &cardNo, &dbID);
  if ((err == errNone) && (dbID != 0)) {
    UInt32 result;
    if (MakeJotEnable) {
      MemPtr cmdPBP = (MemPtr)MemPtrNew(sizeof(SysAppLaunchCmdSystemResetType));
      if (cmdPBP) {
        SysAppLaunchCmdSystemResetType *val;
        MemPtrSetOwner(cmdPBP, 0);
        val = (SysAppLaunchCmdSystemResetType *)cmdPBP;
        val->hardReset = false;
        val->createDefaultDB = false;
        SysAppLaunch(cardNo, dbID, 0/*launch flag must be 0*/,
                     sysAppLaunchCmdSystemReset, cmdPBP, &result);
      }
    } else {
      fFeature = DISABLE_JOT;
      SysAppLaunch(cardNo, dbID, 0, 32801, (char *)&fFeature, NULL);
    }
  }
}

static UInt32
StarterPalmMain(UInt16 cmd, MemPtr /*cmdPBP*/, UInt16 launchFlags)
{
  switch (cmd) {
    case sysAppLaunchCmdNormalLaunch:
      if (!FossilIsWristPDADevice()) {
        return errNone;
      }
      ChangePreferenceVal();
      ChangeJot();
      break;
    default:
      break;
  }
  return errNone;
}

UInt32 PilotMain( UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
  return StarterPalmMain(cmd, cmdPBP, launchFlags);
}
